' *************************************************************************************
'                       Copyright Christopher R. Boss, 2010
'                                All Rights Reserved !
'                 This code is a demo of the new EZGUI 5.0 OpenGL control
' *************************************************************************************
%CanvasW            =    80   ' 80
%CanvasH            =    28   ' 28
%UseCB              =    0    ' use a Callback for GLCanvas for MD2 support

%LotOfObjects       =    0
%MaxObjects         =    250


'
#COMPILE EXE
#DIM ALL        '   This is helpful to prevent errors in coding

GLOBAL UseOneModel&

' --------------------
#INCLUDE "C:\ezgui45beta\includes\ezgui50.inc"                          ' EZGUI Include file for Declares
' --------------------
#IF %UseCB
     #INCLUDE "c:\PBDLL60\ezgui\ezturtle\ez_glu.inc"
#ENDIF

#RESOURCE ".\rcdata\sprites.pbr"


GLOBAL App_UseDoubleBuffer&
GLOBAL App_SpriteCount&
GLOBAL App_UseDisplayList&
GLOBAL App_Optimize&
GLOBAL App_UseBig&


%EZGL_DRAWNOW       =   %EZ_USER+502
%EZGL_SETCALLBACKS  =   %EZ_USER+504


DECLARE SUB GenNormalsX(BYVAL X1!, BYVAL Y1!, BYVAL Z1!,BYVAL X2!, BYVAL Y2!, BYVAL Z2!,BYVAL X3!, BYVAL Y3!, BYVAL Z3!)
' pass 3 coordinate sets to generate a normal for a face

' ------------------------------------------------------------------------------------------------------------------------------------------------------------
' Code below is exmaple code only demonstrating how to use a callback to access the MD2 dll (third party freeware)
' ------------------------------------------------------------------------------------------------------------------------------------------------------------
SUB DoMD2(BYVAL ID&, BYVAL mode&)
     LOCAL F1$,F2$
     STATIC CT&
     SELECT CASE mode&
          CASE -1
'               F1$=EZ_AppPath+"3Dmodels\cmt1.md2"
'               F2$=EZ_AppPath+"3Dmodels\cmt1.bmp"
'               MD2_Load ID&, F1$,F2$
'               F1$=EZ_AppPath+"3Dmodels\cmt2.md2"
'               F2$=EZ_AppPath+"3Dmodels\cmt2.bmp"
'               MD2_Load ID&+1, F1$,F2$
'               CT&=MD2_GetFrameCount(ID&+1)
          CASE 2
'               MD2_Draw ID&, 1
'               glTranslatef -25,13,0
'               glRotatef 180,0,1,0
'               MD2_Draw ID&+1, 1
          CASE -2
'               MD2_Delete ID&
'               MD2_Delete ID&+1
     END SELECT
END SUB

SUB OpenGLCallBack1(BYVAL Msg&, BYVAL Param1&, BYVAL Param2&, BYVAL Param3&, BYVAL Param4 AS DWORD, BYVAL Float1!, BYVAL Float2!, BYVAL Float3!)
     SELECT CASE Msg&
          CASE -1   ' Initialize any data
               DoMD2 3000, -1
          CASE -2   ' free any data
               DoMD2 3000, -2
          CASE 1    ' draw before 3D scene, but after BG bitmap and fill color are drawn
               ' param1& width in pixels
               ' param2& height in pixels
          CASE 2    ' draw custom model during 3D scene
               ' param1& contains object ID
               ' param2& constains 1 if solid, 0 if wireframed
               ' param3& constaints anti-alias flag
               ' param4  contains a codeptr to Controls GenNormalsX routine which you can use to calculate normals
               ' Float1!, Float2!, Float3! contains the current scaling value for each axis (X,Y,Z)
               ' transformations and rotations have already been done
               ' assume center of your object is 0,0,0
               ' assume main area of scene -100 to 100 on all three axis

          #IF %UseCB
               SELECT CASE Param1&
                    CASE 3000
                         DoMD2 3000,2

'                    CASE 3000 ' ID number of object
'                         ' sample custom drawing
'                         glBegin %GL_QUADS
'                              ' normals require 3 points (of 2 lines) with one point shared between them
'                             IF Param4<>0 THEN CALL DWORD Param4 USING GenNormalsX(-100*Float1!, -100*Float2!, 0*Float3!,100*Float1!,-100*Float2!, 0*Float3!,100*Float1!,100*Float2!, 0*Float3! )
'                             glVertex3f  -100*Float1!, -100*Float2!, 0*Float3!
'                             glVertex3f   100*Float1!, -100*Float2!, 0*Float3!
'                             glVertex3f   100*Float1!,  100*Float2!, 0*Float3!
'                             glVertex3f  -100*Float1!,  100*Float2!, 0*Float3!
'                         glEnd
                    CASE ELSE
               END SELECT
          #ENDIF
          CASE 3    ' draw after 3D scene
               ' no parameters
          CASE ELSE
     END SELECT
END SUB

DECLARE FUNCTION Main_Initialize(BYVAL VerNum&) AS LONG
DECLARE SUB OtherForm_Events(FormName$, CID&, CMsg&, CVal&, Cancel&)
DECLARE SUB OtherForm_Design(FormName$)
DECLARE FUNCTION PreProcess_Events(FormName$, CID&, CMsg&, CVal&, Cancel&) AS LONG
DECLARE SUB EZ_SFORM_Display(BYVAL FParent$)
DECLARE SUB EZ_SFORM_Design()
DECLARE SUB EZ_SFORM_ParseEvents(CID&, CMsg&, CVal&, Cancel&)
DECLARE SUB SFORM_Events(CID&, CMsg&, CVal&, Cancel&)


%SFORM_STARTBUTTON        = 100
%SFORM_ZOOMINBUTTON       = 105
%SFORM_ZOOMOUTBUTTON      = 110
%SFORM_BRIGHTUPBUTTON     = 112
%SFORM_BRIGHTDNBUTTON     = 113
%SFORM_BACKGNDBUTTON      = 114
%SFORM_ALPHABUTTON        = 115
%SFORM_FPSCOUNT           = 120
%SFORM_SPCANVAS           = 125
%SFORM_COLLLIST           = 130
%SFORM_FLIPVBUTTON        = 135
%SFORM_FLIPHBUTTON        = 140

DECLARE SUB SFORM_STARTBUTTON_Events(MyID&, CMsg&, CVal&, Cancel&)
DECLARE SUB SFORM_ZOOMINBUTTON_Events(MyID&, CMsg&, CVal&, Cancel&)
DECLARE SUB SFORM_ZOOMOUTBUTTON_Events(MyID&, CMsg&, CVal&, Cancel&)
DECLARE SUB SFORM_ALPHABUTTON_Events(MyID&, CMsg&, CVal&, Cancel&)
DECLARE SUB SFORM_SPCANVAS_Draw(BYVAL FMode&)
DECLARE SUB SFORM_SPCANVAS_Events(MyID&, CMsg&, CVal&, Cancel&)
DECLARE SUB SFORM_FLIPVBUTTON_Events(MyID&, CMsg&, CVal&, Cancel&)
DECLARE SUB SFORM_FLIPHBUTTON_Events(MyID&, CMsg&, CVal&, Cancel&)

' --------------------
$INCLUDE "C:\ezgui45beta\includes\ezwmain50.inc"                          ' EZGUI Include file for WinMain
' --------------------

GLOBAL App_MaxX&, App_MaxY&, App_SWidth&, App_SHeight&
GLOBAL App_MinX&, App_MinY&
GLOBAL App_UpdateFlag&
GLOBAL App_FixedFlag&
GLOBAL App_AlphaFlag&
GLOBAL App_FlipVFlag&
GLOBAL App_FlipHFlag&
GLOBAL App_LastClick$
GLOBAL App_LastSprite&
GLOBAL App_BKMode&

%App_FormOffset     =    0

%App_CheckBG       =    10
%App_CheckFG       =    0
DECLARE SUB SpriteDraw(BYVAL Mode&, BYVAL CVal&)


SUB EZ_Main(VerNum&)
     LOCAL V&
     EZ_Reg %EZ_USER,%EZ_REGNUM

     V&=MSGBOX("Do you want to use Enlarged window ?"+CHR$(13)+CHR$(10)+CHR$(13)+CHR$(10)+"Note: Requires at least a 1200 x 800 screen resolution!", %MB_YESNO,"Window size")

     IF V&=%IDYES THEN

           EZ_DefCharSizeA 14,22

     END IF

     V&=MSGBOX("Do you want to Display an STL Model ?", %MB_YESNO,"Use Model")

     IF V&=%IDYES THEN
          UseOneModel&=1
     ELSE
          UseOneModel&=0
     END IF

IF UseOneModel& THEN


     V&=MSGBOX("Do you want to use see 2D background Sprites ?", %MB_YESNO,"Sprites")

     IF V&=%IDYES THEN
          App_SpriteCount&=4
     ELSE
          App_SpriteCount&=0
     END IF

     V&=MSGBOX("Do you want to use a Display List ?", %MB_YESNO,"Display List")

     IF V&=%IDYES THEN
          App_UseDisplayList&=1
     ELSE
          App_UseDisplayList&=0
     END IF


     V&=MSGBOX("Do you want to use a Optimize Model ?", %MB_YESNO,"Optimize")

     IF V&=%IDYES THEN
          App_Optimize&=1
     ELSE
          App_Optimize&=0
     END IF

     App_UseBig&=0

ELSE
     App_SpriteCount&=0
     App_UseDisplayList&=0
     App_Optimize&=0
     App_UseBig&=0
END IF



     EZ_PreloadGL

     EZ_DefImageFolder "Graphics"
     EZ_AllowCommandEvents  0
     EZ_DefFont 6, "Arial", 10, "BV"
     EZ_DefFont 7, "Courier New", 14, "L+F"
     EZ_DefFont 8, "Times New Roman", 10, "V"
     EZ_DefFont 9, "Modern", 10, "V"
     EZ_DefSystemColor 32, 4
     EZ_DefSystemColor 33, 5
     EZ_DefSystemColor 34, 15
     EZ_DefSystemColor 35, 24
     EZ_DefColorL 36, &HB96FFF
     EZ_DefColorL 37, &H14AB9F
     EZ_DefColorL 38, &H47A7FF
     EZ_DefColorL 39, &HD2AACF
     EZ_DefColorL 40, &H1CD5E3
     EZ_DefColorL 41, &HBC8943
     EZ_DefColorL 42, &H6C6AB7
     EZ_DefColorL 43, &HDD4489

     IF Main_Initialize(VerNum&) THEN
          EZ_SFORM_Display ""
     END IF

END SUB

' -------------------------------------------------------------------------------------

SUB EZ_DesignWindow(FormName$)
     SELECT CASE FormName$
          CASE "SFORM"
               EZ_SFORM_Design
          CASE ELSE
               OtherForm_Design FormName$
     END SELECT
END SUB

' -------------------------------------------------------------------------------------

SUB EZ_Events(FormName$, CID&, CMsg&, CVal&, Cancel&)
     IF PreProcess_Events(FormName$, CID&, CMsg&, CVal&, Cancel&) THEN EXIT SUB
     SELECT CASE FormName$
          CASE "SFORM"
               EZ_SFORM_ParseEvents CID&, CMsg&, CVal&, Cancel&
          CASE ELSE
               OtherForm_Events FormName$, CID&, CMsg&, CVal&, Cancel&
     END SELECT
END SUB

' -------------------------------------------------------------------------------------

FUNCTION Main_Initialize(BYVAL VerNum&) AS LONG
     LOCAL RV&
     EZ_Color %App_CheckFG, %App_CheckBG  ' initialize these colors so they exist
     EZ_DefFont 19, "Arial", 38, "BV"
     EZ_DefFont 20, "Arial", 36, "V"
     RV&=1
     FUNCTION=RV&
END FUNCTION


SUB OtherForm_Design(FormName$)
     SELECT CASE FormName$
          CASE ELSE
     END SELECT
END SUB


SUB OtherForm_Events(FormName$, CID&, CMsg&, CVal&, Cancel&)
     SELECT CASE FormName$
          CASE "{OPENDLG}", "{SAVEDLG}", "{OPENDLGX}", "{SAVEDLGX}", "{COLORDLG}", "{FONTDLG}", "{PRINTDLG}", "{PAGEDLG}", "{FINDDLG}"
          CASE "{ABORTDLG}"
          CASE "{MSGBOX}"
          CASE ELSE
     END SELECT
END SUB


FUNCTION PreProcess_Events(FormName$, CID&, CMsg&, CVal&, Cancel&) AS LONG
     LOCAL RV&
'     EZ_DPrint FormName$+" Cmsg&="+STR$(CMsg&)
     RV&=0
     FUNCTION=RV&
END FUNCTION

GLOBAL App_Zoom&
GLOBAL App_Bright&

SUB EZ_SFORM_Display(BYVAL FParent$)
     EZ_Color 0, 25
     EZ_AllowLoadingEvent 2
     IF App_SpriteCount&<>0 THEN
          EZ_Form "SFORM", FParent$, "OpenGL and 2D Sprites Demo", 0, 0, 80, 32, "_C"
     ELSE
          EZ_Form "SFORM", FParent$, "OpenGL Demo", 0, 0, 80, 32, "_C"
     END IF
END SUB

SUB EZ_SFORM_Design()
     LOCAL CText$

     App_Zoom&=100
     App_Bright&=100
     EZ_Color 0, 25
     EZ_UseFont 4
     EZ_UseAutoSize "CT"
     EZ_ODButton %SFORM_STARTBUTTON, 0, 30, 14.25, 2, "Click to Start Animation", "T"
     EZ_SetRegion "SForm", %SFORM_STARTBUTTON,-2,0
     ' -----------------------------------------------

     EZ_SubClass 4
     EZ_Color 0, 25
     EZ_UseFont 4
     EZ_UseAutoSize "CT"
     EZ_ODButton %SFORM_ZOOMINBUTTON, 14.25, 30, 6.75, 2, "Zoom IN", "T"
     EZ_SetRegion "SForm", %SFORM_ZOOMINBUTTON,-2,0

     ' -----------------------------------------------
     EZ_SubClass 4
     EZ_Color 0, 25
     EZ_UseFont 4
     EZ_UseAutoSize "CT"
     EZ_ODButton %SFORM_ZOOMOUTBUTTON, 21, 30, 6.75, 2, "Zoom OUT", "T"
     EZ_SetRegion "SForm", %SFORM_ZOOMOUTBUTTON,-2,0
     EZ_SubClass 0
     ' -----------------------------------------------
     ' -----------------------------------------------
     EZ_SubClass 4
     EZ_Color 0, 25
     EZ_UseFont 4
     EZ_UseAutoSize "CT"
     EZ_ODButton %SFORM_BRIGHTUPBUTTON, 27.75, 30, 5.75, 2, "Lighten", "T"
     EZ_SetRegion "SForm", %SFORM_BRIGHTUPBUTTON,-2,0
     ' -----------------------------------------------
     EZ_SubClass 4
     EZ_Color 0, 25
     EZ_UseFont 4
     EZ_UseAutoSize "CT"
     EZ_ODButton %SFORM_BRIGHTDNBUTTON, 33.5, 30, 5.25, 2, "Darken", "T"
     EZ_SetRegion "SForm", %SFORM_BRIGHTDNBUTTON,-2,0
     EZ_SubClass 0
     ' -----------------------------------------------


     EZ_Color 0, 25
     EZ_UseFont 4
     EZ_UseAutoSize "CT"
     EZ_ODButton %SFORM_BACKGNDBUTTON, 38.75, 30, 11.5, 2, "Hide Background", "T"
     EZ_SetRegion "SForm", %SFORM_BACKGNDBUTTON,-2,0
     ' -----------------------------------------------


     IF App_SpriteCount&<>0 THEN
          EZ_Color 0, 25
          EZ_UseFont 4
          EZ_UseAutoSize "CT"
          EZ_ODButton %SFORM_ALPHABUTTON, 50.25, 30, 8.25, 2, "Alpha Blend", "T"
          EZ_SetRegion "SForm", %SFORM_ALPHABUTTON,-2,0
     END IF
     ' -----------------------------------------------
     EZ_Color 15, 9
     EZ_UseFont 0
     EZ_UseAutoSize "CT"
     EZ_Label %SFORM_FPSCOUNT, 71, 30, 9, 2, "FPS|0", "C"
     EZ_SetRegion "SForm", %SFORM_FPSCOUNT, 2,0
     ' -----------------------------------------------
     EZ_Color 0, 15
     EZ_UseFont 4
     EZ_UseAutoSize "CT"
     EZ_GLCanvas %SFORM_SPCANVAS, 0, 0, %CanvasW, %CanvasH, "F{DBUF}{DIB}"     ' DIB's and double buffer always used anyway
     SFORM_SPCANVAS_Draw -1
     #IF %UseCB
          ' now only one universal callback
          EZ_SendMessage "SFORM",%SFORM_SPCANVAS,%EZGL_SETCALLBACKS,CODEPTR(OpenGLCallBack1),0
     #ENDIF
     ' -----------------------------------------------
     EZ_Color 0, 25
     EZ_UseFont 4
     EZ_UseAutoSize "CT"
     IF App_SpriteCount&<>0 THEN
          EZ_Label %SFORM_COLLLIST, -0.25, 28, 80, 2, "Collisions with Sprite", "C"
     ELSE
          EZ_Label %SFORM_COLLLIST, -0.25, 28, 80, 2, "Collisions with Sprite", "CH"
     END IF
     ' -----------------------------------------------
     IF App_SpriteCount&<>0 THEN
          EZ_Color 0, 25
          EZ_UseFont 4
          EZ_UseAutoSize "CT"
          EZ_ODButton %SFORM_FLIPVBUTTON, 58.5, 30, 6.25, 2, "Flip Vert.", "T"
          EZ_SetRegion "SForm", %SFORM_FLIPVBUTTON,-2,0
          ' -----------------------------------------------
          EZ_Color 0, 25
          EZ_UseFont 4
          EZ_UseAutoSize "CT"
          EZ_ODButton %SFORM_FLIPHBUTTON, 64.75, 30, 6.25, 2, "Flip Horz.", "T"
          EZ_SetRegion "SForm", %SFORM_FLIPHBUTTON,-2,0
     END IF
     ' -----------------------------------------------
END SUB


SUB EZ_SFORM_ParseEvents(CID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CID&
          CASE %EZ_Window
               SFORM_Events CID&, CMsg&, CVal&, Cancel&
          CASE  %SFORM_STARTBUTTON
               SFORM_STARTBUTTON_Events CID&, CMsg&, CVal&, Cancel&
               IF CMsg&=%EZ_OwnerDraw THEN
                    EZ_Draw3DButtonRR "SForm", %SFORM_STARTBUTTON, CVal&, 25, 0,  4
               END IF
          CASE %SFORM_BRIGHTUPBUTTON
               IF CMsg&=%EZ_OwnerDraw THEN
                    EZ_Draw3DButtonRR "SForm", %SFORM_BRIGHTUPBUTTON, CVal&, 25, 0,  4
               END IF
               IF CMsg&=%EZ_Click THEN
                    IF App_Bright&<200 THEN
                         App_Bright&=App_Bright&+5
                         EZ_DoGL "SForm", %SFORM_SPCANVAS,"BRIGHT "+STR$(App_Bright&)
                         EZ_RedrawControl "SForm", %SFORM_SPCANVAS
                         EZ_SetText "SForm",0, "Zoom ="+STR$(App_Zoom&)+"  Brightness ="+STR$(App_Bright&)
                    END IF
               END IF
          CASE %SFORM_BRIGHTDNBUTTON
               IF CMsg&=%EZ_OwnerDraw THEN
                    EZ_Draw3DButtonRR "SForm", %SFORM_BRIGHTDNBUTTON, CVal&, 25, 0,  4
               END IF
               IF CMsg&=%EZ_Click THEN
                    IF App_Bright&>1 THEN
                         App_Bright&=App_Bright&-5
                         IF App_Bright&<1 THEN App_Bright&=1
                         EZ_DoGL "SForm", %SFORM_SPCANVAS,"BRIGHT "+STR$(App_Bright&)
                         EZ_RedrawControl "SForm", %SFORM_SPCANVAS
                         EZ_SetText "SForm",0, "Zoom ="+STR$(App_Zoom&)+"  Brightness ="+STR$(App_Bright&)
                    END IF
               END IF
          CASE %SFORM_BACKGNDBUTTON
               IF CMsg&=%EZ_OwnerDraw THEN
                    EZ_Draw3DButtonRR "SForm", %SFORM_BACKGNDBUTTON, CVal&, 25, 0,  4
               END IF
               IF CMsg&=%EZ_Loaded THEN
                    App_BKMode&=1
               END IF
               IF CMsg&=%EZ_Click THEN
                    IF App_BKMode&=1 THEN
                         App_BKMode&=0
                         EZ_SetText "SForm", %SFORM_BACKGNDBUTTON, "Show Background"
                    ELSE
                         App_BKMode&=1
                         EZ_SetText "SForm", %SFORM_BACKGNDBUTTON, "Hide Background"
                    END IF
                    EZ_DoGL "SForm", %SFORM_SPCANVAS,"BGMODE "+STR$(App_BKMode&)
               END IF
          CASE  %SFORM_ZOOMINBUTTON
               SFORM_ZOOMINBUTTON_Events CID&, CMsg&, CVal&, Cancel&
          CASE  %SFORM_ZOOMOUTBUTTON
               SFORM_ZOOMOUTBUTTON_Events CID&, CMsg&, CVal&, Cancel&
          CASE  %SFORM_ALPHABUTTON
               SFORM_ALPHABUTTON_Events CID&, CMsg&, CVal&, Cancel&
          CASE  %SFORM_SPCANVAS
               SFORM_SPCANVAS_Events CID&, CMsg&, CVal&, Cancel&
          CASE  %SFORM_FLIPVBUTTON
               SFORM_FLIPVBUTTON_Events CID&, CMsg&, CVal&, Cancel&
          CASE  %SFORM_FLIPHBUTTON
               SFORM_FLIPHBUTTON_Events CID&, CMsg&, CVal&, Cancel&
          CASE ELSE
               SFORM_Events CID&, CMsg&, CVal&, Cancel&
     END SELECT
END SUB

SUB SFORM_Events(CID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CID&
          CASE %EZ_Window
               SELECT CASE CMsg&
                    CASE %EZ_GameLoop
                          SpriteDraw 0, CVal&
                    CASE %EZ_Loading
                         LOCAL T$
                         IF UseOneModel& THEN
                              T$="Spaceship Model"
                         ELSE
                              T$="3D Primitives"
                         END IF
                         IF App_SpriteCount&<>0 THEN
                              EZ_SetLoadStr "T", T$+" and 2D Sprites Demo ("+STR$(App_SpriteCount&)+" Sprites active)"
                         ELSE
                              EZ_SetLoadStr "T", T$+" Demo"
                         END IF
                    CASE %EZ_Loaded

                    CASE %EZ_Started
                         Change3DStuff
                         InitObjects %SFORM_SPCANVAS
                         EZ_DelayDrawClient "SFORM", %SFORM_SPCANVAS
                    CASE %EZ_Close
                         EZ_DefGameLoop "", 0, 0
                    CASE ELSE
               END SELECT
          CASE ELSE
     END SELECT
END SUB


SUB MakeSprites()
    LOCAL P$, SName$, N&, SNameAll$, P2$, hDC&, T$
    EZ_InitSpriteBuffers App_SpriteCount&,-1,-1
    App_LastSprite&=App_SpriteCount&
    P$=EZ_LoadPicture("ball3d.bmp")
    EZ_GetPictureSize P$,App_SWidth&, App_SHeight&
    FOR N&=1 TO App_SpriteCount&
        SName$="LOGO"+TRIM$(STR$(N&))
        T$=TRIM$(STR$(N&))
        P2$=EZ_CreatePicture(App_SWidth&,App_SHeight&)
        hDC&=EZ_StartPictureDraw(P2$)
        IF hDC&<>0 THEN
            EZ_DCDrawPicture hDC&, 0,0,App_SWidth&,App_SHeight&, EZ_ImageHandle(P$)
            EZ_SetPrintFormat 2,App_SWidth&-1,App_SHeight&-1, %EZ_Center OR %EZ_VCenter, 0
            EZ_UseFont 19
            EZ_Color 0,0
            EZ_DCPrint hDC&, 0,0, T$
            IF N&=App_SpriteCount& THEN
                EZ_Color 14,0
            ELSE
                EZ_Color 12,0
            END IF
            EZ_UseFont 20
            EZ_DCPrint hDC&, 0,0, T$
            EZ_SetPrintFormat 0,0,0,0,0
        END IF
        EZ_EndPictureDraw

        SNameAll$=SNameAll$+SName$+"|"
        EZ_DefSpriteByPict SName$, P2$,1, -1, 0


        EZ_FreeImage P2$
    NEXT N&
    EZ_FreeImage P$
    EZ_AssignSprites "SForm", %SFORM_SPCANVAS, SNameAll$
    EZ_SetSpritesEffect SNameAll$, 1,0
END SUB
'
GLOBAL App_XY&()
'
FUNCTION GetX(BYVAL N&) AS LONG
    LOCAL X&
    X&=N&+2
    IF App_XY&(N&,1)>=App_MaxX&-App_SWidth& THEN App_XY&(N&,3)=-1
    IF App_XY&(N&,1)<=App_MinX& THEN App_XY&(N&,3)=1
    X&=X&*App_XY&(N&,3)
    App_XY&(N&,1)=App_XY&(N&,1)+X&
    FUNCTION=App_XY&(N&,1)
END FUNCTION
'
FUNCTION GetY(BYVAL N&) AS LONG
    LOCAL Y&
    Y&=N&+2
    IF App_XY&(N&,2)>=App_MaxY&-App_SHeight& THEN App_XY&(N&,4)=-1
    IF App_XY&(N&,2)<=App_MinY& THEN App_XY&(N&,4)=1
    Y&=Y&*App_XY&(N&,4)
    App_XY&(N&,2)=App_XY&(N&,2)+Y
    FUNCTION=App_XY&(N&,2)
END FUNCTION

'
SUB Change3DStuff()
     LOCAL J&
     STATIC IFlag&
     STATIC Distance!, DPlus!
     IF IFlag&=0 THEN
          IFlag&=1
          EZ_DoGL "SForm", %SFORM_SPCANVAS,"LIGHTYX 45,45|LIGHTZ 1000|LIGHTAD 40,60|LIGHT2 1|LIGHT2YX 315,45|LIGHT2Z 1000|LIGHT2AD 20,30"
          EZ_DoGL "SForm", %SFORM_SPCANVAS,"QALL 1|BGCOLOR &H000000"
     END IF
     IF Distance!=0 THEN
         Distance!=20
         DPlus!=.1
     END IF
     Distance!=Distance!+DPlus!
     IF Distance!<15 THEN
         Distance!=15
         DPlus!=.1
     END IF
     IF Distance!>50 THEN
         Distance!=50
         DPlus!=-.1
     END IF
     #IF %UseCB

     #ELSE

     #ENDIF

     EZ_DoGL "SForm", %SFORM_SPCANVAS,"PERSPECTIVE "+STR$(Distance!)

    STATIC RD!, RD1!
    RD=RD+2
    IF RD>360 THEN RD=0

    RD1!=RD1!+1
    IF RD1!>360 THEN RD1!=0

    IF EZ_StartGL("SForm", %SFORM_SPCANVAS) THEN
         #IF %LotOfObjects
              FOR J&=1 TO %MaxObjects
                   EZ_GL "ROTATE "+STR$(999+J&)+"+,"+STR$(RD)+","+STR$(RD)+",0"
                   EZ_GL "SROTATE "+STR$(999+J&)+",0,"+STR$(RD1+(J&*2))+",0"
              NEXT J&

         #ELSE

              IF UseOneModel& THEN
                   #IF %UseCB
                         ' this is a custom object drawn in callback routine
                        EZ_GL "ROTATE 3000,0,"+STR$(360-RD)+",0"
'                        EZ_GL "SROTATE 3000,0,"+STR$(RD1)+",0"
                    #ELSE
                        ' this is a custom object drawn in callback routine
                        EZ_GL "ROTATE 3000,"+STR$(RD)+","+STR$(360-RD)+",0"
                        EZ_GL "SROTATE 3000,0,"+STR$(RD1)+",0"
                    #ENDIF
              ELSE
                   EZ_GL "ROTATE 1000,"+STR$(RD)+","+STR$(RD)+",0"
                   EZ_GL "SROTATE 1000,0,"+STR$(RD1)+",0"

                   EZ_GL "ROTATE 1001,"+STR$(RD)+","+STR$(RD)+",0"
                   EZ_GL "SROTATE 1001,0,"+STR$(RD1)+",0"
                   EZ_GL "ROTATE 1002,0,"+STR$(RD)+",0"
                   EZ_GL "SROTATE 1002,0,"+STR$(RD1)+",0"
                   EZ_GL "ROTATE 1003,0,"+STR$(RD)+",0"
                   EZ_GL "SROTATE 1003,0,"+STR$(RD1)+",0"
                   EZ_GL "ROTATE 1004,0,"+STR$(RD)+",0"
                   EZ_GL "SROTATE 1004,0,"+STR$(RD1)+",0"
                   EZ_GL "ROTATE 1005,0,"+STR$(360-RD)+",0"
                   EZ_GL "SROTATE 1005,0,"+STR$(RD1)+",0"
                   EZ_GL "ROTATE 1006,0,"+STR$(RD)+",0"
                   EZ_GL "SROTATE 1006,0,"+STR$(RD1)+",0"

              END IF
         #ENDIF
         EZ_EndGL
    END IF
END SUB

SUB SpriteDraw(BYVAL Mode&, BYVAL CVal&)
    LOCAL EF&, ToggleX&, ToggleY&
    LOCAL SName$, PW&, N&, T$
    STATIC Count&, CT!
    STATIC TM!, GLP_CT&
    STATIC AvSleep&
    STATIC DTextCT&
    GLP_CT&=GLP_CT&+1
    IF GLP_CT&>32000 THEN GLP_CT&=1
    IF Mode&=1 THEN
        AvSleep&=0
        Count&=1
        REDIM App_XY&(1 TO App_SpriteCount&, 1 TO 4)
        IF App_SpriteCount&<>0 THEN
             FOR N&=1 TO App_SpriteCount&
                 SName$="LOGO"+TRIM$(STR$(N&))
                 EZ_MoveSprites SName$, N&,N&,0
                 App_XY&(N&,1)=N&
                 App_XY&(N&,2)=N&
                 App_XY&(N&,3)=1
                 App_XY&(N&,4)=1
                 EZ_ShowSprites SName$,1
             NEXT N&
        END IF
    ELSE
        IF CVal&=1 THEN TM!=EZ_GetPTime
        IF App_SpriteCount&<>0 THEN
             IF App_FixedFlag& THEN
                 EZ_StartFrame
             END IF
             EF&=0
             IF App_AlphaFlag& THEN EF&=50
             FOR N&=1 TO App_LastSprite&
                 SName$="LOGO"+TRIM$(STR$(N&))
                 EZ_SetSpritesEffect SName$, EF&,0
                 EZ_SetSpritesFlip SName$, App_FlipHFlag&,App_FlipVFlag&, 0
                 EZ_MoveSprites SName$, GetX(N&),GetY(N&),0
     '            IF App_UpdateFlag& THEN
     '                EZ_UpdateClient "{ME}", %SFORM_SPCANVAS
     '            END IF
             NEXT N&
        END IF
        Change3DStuff
        IF App_SpriteCount&<>0 THEN
             IF App_UpdateFlag&=0 THEN
                 IF App_LastSprite&=0 THEN
                      EZ_DelayDrawClient "{ME}", %SFORM_SPCANVAS
                 ELSE
                      EZ_UpdateClient "{ME}", %SFORM_SPCANVAS
                 END IF
             END IF
        ELSE
             EZ_SendMessage "{ME}", %SFORM_SPCANVAS, %EZGL_DRAWNOW,0,0
'             EZ_RedrawControl "{ME}", %SFORM_SPCANVAS
        END IF
        IF App_FixedFlag& THEN
            IF App_SpriteCount&<>0 THEN
                 IF AvSleep&>0 THEN SLEEP AvSleep&
                 EZ_EndFrame 24,0
                 IF EZ_GetFrameInfo(0) THEN
                   ' can't keep up to frame rate
                 ELSE
               ' if Frame rate does not require all the CPU then free it up next iteration
                    AvSleep&=EZ_GetFrameInfo(4)*.95
                 END IF
            END IF
        END IF
        IF CVal&=100 THEN
            TM!=EZ_GetPTime-TM!
            IF TM!<=0 THEN TM!=1
            TM!=INT((100/TM!)*100)/100
            EZ_SetText "{ME}", %SFORM_FPSCOUNT, TRIM$(STR$(TM!))+CHR$(13)+CHR$(10)+"FPS"
        END IF
'        DTextCT&=DTextCT&+1
'        if DTextCT&>=50 then
'             DTextCT&=0
'             T$=EZ_TestSpriteColl("LOGO"+TRIM$(STR$(App_LastSprite&)))
'             T$=REMOVE$(T$,"LOGO")
'             REPLACE "|" WITH " , " IN T$
'             T$="Collisions with Sprite"+STR$(App_LastSprite&)+" :      "+T$
'             IF App_LastClick$<>"" THEN
'                  T$=T$+"|Last Sprite Clicked:    "+App_LastClick$
'             END IF
'             EZ_SetText "{ME}", %SFORM_COLLLIST, T$
'        end if
    END IF
END SUB
'
SUB DoBUTTON_Click()
    LOCAL N&, CT!, EF&, Frame&
    STATIC Count&, RunFlag&
    IF Count&=0 THEN
        Count&=1
        MakeSprites ' should be off screen
    END IF
    App_LastClick$=""
    IF RunFlag&=0 THEN
        SpriteDraw 1,0
        EZ_DefGameLoop "SForm", 0, 105
        EZ_SetText "SForm", %SFORM_STARTBUTTON, "Click to Stop Animation"
        RunFlag&=1
    ELSE
        EZ_DefGameLoop "", 0, 0
        EZ_SetText "SForm", %SFORM_STARTBUTTON, "Click to Start Animation"
        RunFlag&=0
    END IF
END SUB
'<<END>>

SUB SFORM_STARTBUTTON_Events( MyID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CMsg&
          CASE %EZ_Click
               DoBUTTON_Click
          CASE ELSE
     END SELECT
END SUB


SUB SFORM_ZOOMINBUTTON_Events( MyID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CMsg&
          CASE %EZ_Click
               IF App_Zoom&<100 THEN
                    App_Zoom&=App_Zoom&+5
                    EZ_DoGL "SForm", %SFORM_SPCANVAS, "ZOOM "+STR$(App_Zoom&)+","+STR$(App_Zoom&)
                    EZ_RedrawControl "SForm", %SFORM_SPCANVAS
                    EZ_SetText "SForm",0, "Zoom ="+STR$(App_Zoom&)+"  Brightness ="+STR$(App_Bright&)
               END IF
          CASE %EZ_OwnerDraw
               IF App_UpdateFlag&=0 THEN
                    EZ_Draw3DButtonRR "SForm", %SFORM_ZOOMINBUTTON, CVal&, 25, 0,  4
               ELSE
                    EZ_Draw3DButtonRR "SForm", %SFORM_ZOOMINBUTTON, CVal&, %App_CheckBG, %App_CheckFG,  4
               END IF
          CASE ELSE
     END SELECT
END SUB


SUB SFORM_ZOOMOUTBUTTON_Events( MyID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CMsg&
          CASE %EZ_Click
               IF App_Zoom&>10 THEN
                    App_Zoom&=App_Zoom&-5
                    EZ_DoGL "SForm", %SFORM_SPCANVAS, "ZOOM "+STR$(App_Zoom&)+","+STR$(App_Zoom&)
                    EZ_RedrawControl "SForm", %SFORM_SPCANVAS
                    EZ_SetText "SForm",0, "Zoom ="+STR$(App_Zoom&)+"  Brightness ="+STR$(App_Bright&)
               END IF
          CASE %EZ_OwnerDraw
               IF App_FixedFlag&=0 THEN
                    EZ_Draw3DButtonRR "SForm", %SFORM_ZOOMOUTBUTTON, CVal&, 25, 0,  4
               ELSE
                    EZ_Draw3DButtonRR "SForm", %SFORM_ZOOMOUTBUTTON, CVal&, %App_CheckBG, %App_CheckFG,  4
               END IF
          CASE ELSE
     END SELECT
END SUB


SUB SFORM_ALPHABUTTON_Events( MyID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CMsg&
          CASE %EZ_Click
               IF App_AlphaFlag&=0 THEN App_AlphaFlag&=1 ELSE App_AlphaFlag&=0
               EZ_SetFocus "SForm", %SFORM_STARTBUTTON
               EZ_RedrawControl "SForm", %SFORM_ALPHABUTTON
          CASE %EZ_OwnerDraw
               IF App_AlphaFlag&=0 THEN
                    EZ_Draw3DButtonRR "SForm", %SFORM_ALPHABUTTON, CVal&, 25, 0,  4
               ELSE
                    EZ_Draw3DButtonRR "SForm", %SFORM_ALPHABUTTON, CVal&, %App_CheckBG, %App_CheckFG,  4
               END IF
          CASE ELSE
     END SELECT
END SUB


SUB SFORM_SPCANVAS_Draw(BYVAL FMode&)
    LOCAL CW&, CH&, P$
    IF FMode&=-1 THEN    ' Initial Data
        EZ_SaveState
        EZ_GetCanvasSize "SForm", %SFORM_SPCANVAS, CW&, CH&
        App_MaxX&=(CW&-1)+%App_FormOffset
        App_MaxY&=(CH&-1)+%App_FormOffset
        App_MinX&=0-%App_FormOffset
        App_MinY&=0-%App_FormOffset
        EZ_StartDraw "SForm", %SFORM_SPCANVAS, CW&, CH&, ""
        EZ_Color 0,0
        EZ_CDraw %EZ_FILL,0,0, CW&-1, CH&-1,0,1
        P$=EZ_LoadPicture("bg01.bmp")
        EZ_CDrawPicture 0,0, CW&, CH&, P$,""
        EZ_FreeImage P$
        EZ_EndDraw
        EZ_RestoreState
    END IF
END SUB


SUB ClickSprite(BYVAL MyID&, BYVAL CMsg&, BYVAL CVal&)
     LOCAL X&, Y&, SPN$
     EZ_GetCanvasXY "{ME}", MyID&, X&,Y&,0,0
     SPN$ = EZ_TestSpriteClick("{ME}", MyID&, X&, Y&)
     App_LastClick$=SPN$
END SUB

SUB InitObjects(BYVAL MyID&)
     LOCAL J&, T$, P$
     IF EZ_StartGL("{ME}", MyID&) THEN

     IF UseOneModel& THEN
     #IF %UseCB
         EZ_GL "MATCOLOR 990,&HFFFFFF,100,100"
         EZ_GL "ADD CUSTOM,3000,0,-60,0, 1,1,1,990,1"
         EZ_GL "SCALE 3000,1.25,1.25,1.25"
         EZ_GL "BGCOLOR &HFFFFFF"
         EZ_GL "LIGHTYX 45,45|LIGHTZ 200|LIGHTAD 100,100"
         EZ_GL "LIGHT2YX 315,45|LIGHT2Z 200|LIGHT2AD 100,100"

     #ELSE



          ' last paramater of LOADNEW command is as follows:
          ' 1 - AutoScale to Resize Object to aproximately window size
          ' 2 - AutoScale and swap X,Y axis
          ' 3 - AutoScale and swap X,Y axis and autogen Normals
          ' 4 - AutoScale and autogen Normals

          P$=EZ_AppPath
          EZ_GL "LOADNEW MODEL1,"+P$+"space1.stl,2"


          EZ_ExecGL
          T$=EZ_GetGL
          EZ_GL "ADD MODEL1,3000,0,0,0, 1,1,1,72,1"  ' use color 66
          IF App_UseBig& THEN
               EZ_GL "SCALE 3000,1,2,1"
          ELSE
               EZ_GL "SCALE 3000,1,2,1"
          END IF

          IF App_Optimize& THEN
               EZ_GL "OPTIMIZE MODEL1"
          END IF

          IF App_UseDisplayList& THEN
               EZ_GL "LOCK 3000"
          END IF


     #ENDIF
     ELSE
         #IF %LotOfObjects
              FOR J&=1 TO %MaxObjects
                   EZ_GL "ADD CUBE,"+STR$(999+J&)+","+STR$((J&*.5)-125)+","+STR$(50-(J&*.5))+",0, 1,1,1,65,0"
                   EZ_GL "SCALE "+STR$(999+J&)+",.25,.25,.25"
'                   EZ_GL "LOCK "+STR$(999+J&)
              NEXT J&
         #ELSE
              EZ_GL "MATPAT 990,&H0088FF,100,100,6,0,8"
              EZ_GL "DEFPAL 2,81,82,83,84,85,111"
              EZ_GL "ADD CUBE, 1000, -100,50,0, 1,1,1,38,0"
              EZ_GL "MAT 1000,2,2"
              EZ_GL "SCALE 1000,.33,.33,.33"
              EZ_GL "ALIAS 1000,1"

              EZ_GL "MATSETALPHA 68, 35"
              EZ_GL "ADD PYRAMID,1001, 125,50,0, 1,1,1,68,0"     ' 81
              EZ_GL "SCALE 1001,.5,.5,.5"
              EZ_GL "ADD CUBE,1002,-100,-50,0, .5,1,.25,81,0"
              EZ_GL "SCALE 1002,3.0,.25,.25"
              EZ_GL "WIRE 1002, 1"
              EZ_GL "LWIDTH 1002, 3.0"
              EZ_GL "ALIAS 1002,1"

              EZ_GL "ADD SPHERE_Q,1003,125,-50,0, 1,1,1,89,0"     ' 74
              EZ_GL "SCALE 1003,.25,.25,.25"
              EZ_GL "ADD CONE_C,1004,0,-50,-95,1,1,1,74,0"
              EZ_GL "SCALE 1004,.25,.25,.25"
              EZ_GL "ALIAS 1004,1"

              EZ_GL "ADD SPHERE_F,1005,-140,-50,50, 1,1,1,75,0"
              EZ_GL "SCALE 1005,.33,.33,.33"
              EZ_GL "WIRE 1005,1"
              EZ_GL "ALIAS 1005,1"
              EZ_GL "ADD MOON,1006,125,-50,0, 1,1,1,77,0"
              EZ_GL "SCALE 1006,.25,.25,.25"




         #ENDIF

     END IF

         EZ_EndGL
END IF
END SUB
'<<END>>
SUB SFORM_SPCANVAS_Events( MyID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CMsg&
          CASE %EZ_Click
               ClickSprite MyID&, CMsg&, CVal&
          CASE %EZ_Loaded
          CASE ELSE
     END SELECT
END SUB

SUB SFORM_FLIPVBUTTON_Events( MyID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CMsg&
          CASE %EZ_Click
               IF App_FlipVFlag&=0 THEN App_FlipVFlag&=1 ELSE App_FlipVFlag&=0
               EZ_SetFocus "{ME}", %SFORM_STARTBUTTON
               EZ_RedrawControl "{ME}", %SFORM_FLIPVBUTTON
          CASE %EZ_OwnerDraw
               IF App_FlipVFlag&=0 THEN
                    EZ_Draw3DButtonRR "{ME}", %SFORM_FLIPVBUTTON, CVal&, 25, 0,  4
               ELSE
                    EZ_Draw3DButtonRR "{ME}", %SFORM_FLIPVBUTTON, CVal&, %App_CheckBG, %App_CheckFG,  4
               END IF
          CASE ELSE
     END SELECT
END SUB

SUB SFORM_FLIPHBUTTON_Events( MyID&, CMsg&, CVal&, Cancel&)
     SELECT CASE CMsg&
          CASE %EZ_Click
               IF App_FlipHFlag&=0 THEN App_FlipHFlag&=1 ELSE App_FlipHFlag&=0
               EZ_SetFocus "{ME}", %SFORM_STARTBUTTON
               EZ_RedrawControl "{ME}", %SFORM_FLIPHBUTTON
          CASE %EZ_OwnerDraw
               IF App_FlipHFlag&=0 THEN
                    EZ_Draw3DButtonRR "{ME}", %SFORM_FLIPHBUTTON, CVal&, 25, 0,  4
               ELSE
                    EZ_Draw3DButtonRR "{ME}", %SFORM_FLIPHBUTTON, CVal&, %App_CheckBG, %App_CheckFG,  4
               END IF
          CASE ELSE
     END SELECT
END SUB
